---
layout: layouts/exercise_python.njk
exercise: 4
points: 9
---
{% include 'blocks/teams_of_two.njk' %}

<ol>
  <li><strong>Telephone numbers with letters</strong><br />
    In some countries it is a common practice to encode selected telephone
    numbers as text because they are easier to memorize that way. The letters
    of the text signal which button to press on a telephone keypad. See the
    image below as a reference:<br />
    <img src="https://upload.wikimedia.org/wikipedia/commons/4/43/Telephone-keypad.svg"
         style="display: block; margin: 0.2cm auto;" />
    <cite style="display: block; text-align: center;">Source: Marnanel (<a href="http://commons.wikimedia.org/wiki/File%3ATelephone-keypad.svg">via Wikimedia Commons</a>)</cite>
    <br />
    Implement a function <code>as_numeric(text)</code> that returns a string
    containing only the numbers that correspond to the input text. Using the
    function in a python3 shell should look like this:
<pre>
&gt;&gt;&gt; as_numeric('0800 reimann')
'0800 7346266'
</pre>
    Hint: using a Python dictionary to store the translation table facilitates
    this task.<br />
    Name the program file: <kbd>telephone_numbers.py</kbd>
  </li>
  <li>
    <strong>Working on existing programs</strong> (2 points)<br/>
    Your lecturer just started riding the fake news wave. In order to illustrate
    how much fake new is out there, he wrote a little fake news generator.
    However, the generator is far from perfect.<br />
    In order for the generator to work you need to install the
    <code>faker</code> and <code>wikipedia</code> packages using<br />
    <code>sudo pip3 install --user faker wikipedia</code><br />
    The little script deliberately makes
    use of a selection of libraries to illustrate the power of Python. At the
    same time the example illustrates that you do not have to understand
    every line of a script in order to improve it. Start by playing around
    with the fake news generator from the commandline:
    <code>python3 fake_news_generator.py -h</code><br />

    Your lecturer needs your help to create messages that are more credible.
    At the moment, the messages are given credit by adding a "source". Let's
    assume female sources are more credible. Find the line that adds the name
    of the the source and adjust it to only use female names (check the
    documentation of the faker module if needed).<br />

    Furthermore, the module can use an article from Wikipedia as source for the
    list of words that make up the fake news. It also contains a function to
    remove non-word characters from wordlists. However, this function is
    currently not applied. Make sure
    it is applied, but only for the Wikipedia articles - not for the carefully
    handpicked tweets which serve as default inputs.<br />

    Name the program file: <kbd>fake_news_generator.py</kbd>
<!--    In his book "Programming in Python 3", Mark Summerfield introduces a small
    Python program that creates HTML files with some user defined input.
    Have a look at the file
    <kbd>make_html_skeleton.py</kbd> and run it
    a few times. Try to understand roughly how it does its job. Then change it
    such that there are no description or keyword tags in the output. To do
    this, remove the corresponding text from the HTML_TEMPLATE's head tag. Also
    remove the parts responsible for collecting and handling the keywords and the
    description.<br />
    As websites use more and more JavaScript, add the following line to the
    output (after the last &lt;meta&gt; tag):<br />
    <code>&lt;script src="http://code.jquery.com/jquery-1.10.1.min.js"&gt;&lt;/script&gt;</code>
    <br />
    In addition to the above, ask if the user wants to add additional Links to
    JavaScript files. For each of the given files, add<br />
    <code>&lt;script src="FILENAME" type="text/javascript"&gt;&lt;/script&gt;</code>
    <br />
    to the output,
    where FILENAME is the name of the file the user provided. In order to do
    this, change the function signature of
    <code>make_html_skeleton(.)</code> to contain a
    new optional parameter named <code>scripts</code> (list of strings). Each of the strings then represents a javascript file path (eg. <code>scripts=['js/test.js',
                                                       'js/other.js']</code>).
    <br/>
    Name the program file: <kbd>make_html_skeleton.py</kbd>-->
  </li>
  <li>
    <strong>Basic statistics</strong> (2 points)<br/>
    Write a few functions that compute basic statistics from given financial
    data stored in CSV files. The input files have to have column headers in
    their first row. As you'll have to be able to deal with bigger amounts
    of data, it cannot be guaranteed that all of the data can fit
    your computer's
    memory. To help you out with this situation, you can use the provided
    function <code>items(.)</code> yielding one row of the data after the
    other when being iterated over. The rows are yielded as dictionaries using
    the first row as keys. The provided <code>count(.)</code> function gives an
    idea on how to use the <code>items(.)</code> generator function. Doing this
    correctly for <code>find_median(.)</code> is a bonus challenge. If you do
    not manage to implement this under the memory constraints just implement it
    ignoring them.<br />

    You need to create a series of functions that compute the required values:
    <br />
    <code>calc_max(.)</code><br />
    <code>calc_min(.)</code><br />
    <code>calc_mean(.)</code><br />
    <code>calc_stddev(.)</code><br />
    <code>calc_sum(.)</code><br />
    <code>calc_variance(.)</code><br />
    <code>calc_median(.)</code><br />

    In order for the grader to work, install the numpy package via
    <kbd>pip install --user numpy</kbd>.

    Name the program file: <kbd>statistics.py</kbd>
  </li>
  <li><strong>Counting unique words in a file</strong> (4 points)<br/>
    In a prior 'Information Science' course at University of Graz, one of the
    task was to count how many times each word in an article occurs. To
    alleviate checking if someone performed such a task correctly,
    write a Python program that does the work for you. You don't
    have to write the entire program from scratch. Instead, use the provided
    <kbd>count_unique.py</kbd> file and implement
    <code>count_unique(words)</code>.<br />
    Also implement <code>count_unique_sorted(words)</code> that
    returns a list of named tuples. The first element of each named tuple must
    be '<code>word</code>' and the second '<code>count</code>'. The list has to
    contain the tuples in the same order as the words occur in the input
    file.<br />
    Name the program file: <kbd>unique_words.py</kbd>
  </li>
</ol>
